Отправка сообщений в slack из консоли bash

В корпоративный мессенджер slack можно отправлять сообщения напрямую из консоли linux. Это может быть полезно, например, для уведомлений отработки скриптов по cron`у. Сначала включим в slack входящие вебхуки: Manage — Custom integrations — Incoming Webhooks — Add Configuration.

После настройки нам необходимо получить Webhook URL. Он имеет такой вид:

 
https://hooks.slack.com/services/AAAAAAAAA/BBBBBBBBB/CCCCCCCCCCCCCCCCCCCCCCCC

Далее идем на сервер, с которого планируется отправлять сообщения в slack. Нам потребуется создать скрипт, который будет выполнять отправку (за скрипт спасибо andkirby). Его можно развернуть двумя способами.

Способ 1 — подтянуть curl`ом с github.

 
curl -s https://gist.githubusercontent.com/andkirby/67a774513215d7ba06384186dd441d9e/raw --output /usr/bin/slack

Cпособ 2 — скопировать листинг файла отсюда и положить его в /usr/bin/slack вручную.

 
#!/usr/bin/env bash
####################################################################################
# USAGE
# Send message to slack channel/user
#   Send a message to the channel #ch-01
#     $ bash slack.sh '#ch-01' 'Some message here.'
#
#   Send a message to the channel #ch-01 and user @me.
#     $ bash slack.sh '#ch-01,@me' MESSAGE
#
#   Send a message to the default channel (it must be declared in APP_SLACK_CHANNEL).
#     $ bash slack.sh MESSAGE
#
# VARIABLES
#
# Please declare environment variables:
#   - APP_SLACK_WEBHOOK
#   - APP_SLACK_CHANNEL (optional)
#   - APP_SLACK_USERNAME (optional)
#   - APP_SLACK_ICON_EMOJI (optional)
# You may also declare them in ~/.slackrc file.
####################################################################################

set -o pipefail
set -o errexit
set -o nounset
#set -o xtrace

init_params() {
  # you may declare ENV vars in /etc/profile.d/slack.sh
  if [ -z "${APP_SLACK_WEBHOOK:-}" ]; then
    echo 'error: Please configure Slack environment variable: ' /dev/stderr
    echo '  APP_SLACK_WEBHOOK' /dev/stderr
    exit 2
  fi

  APP_SLACK_USERNAME=${APP_SLACK_USERNAME:-$(hostname | cut --delimiter=. --fields=1)}
  APP_SLACK_ICON_EMOJI=${APP_SLACK_ICON_EMOJI:-:slack:}
  if [ -z "${1:-}" ]; then
    echo 'error: Missed required arguments.' /dev/stderr
    echo 'note: Please follow this example:' /dev/stderr
    echo '  $ slack.sh "#CHANNEL1,CHANNEL2" Some message here. '  /dev/stderr
    exit 3
  fi

  slack_channels=(${APP_SLACK_CHANNEL:-})
  if [ "${1::1}" == '#' ] || [ "${1::1}" == '@' ]; then
    # explode by comma
    IFS=',' read -r -a slack_channels  "${1}"
    shift
  fi
  slack_message=${@}
}

 

send_message() {
  local channel=${1}
  echo 'Sending to '${channel}'...'
  curl --silent --data-urlencode \
    "$(printf 'payload={"text": "%s", "channel": "%s", "username": "%s", "as_user": "true", "link_names": "true", "icon_emoji": "%s" }' \
        "${slack_message}" \
        "${channel}" \
        "${APP_SLACK_USERNAME}" \
        "${APP_SLACK_ICON_EMOJI}" \
    )" \
    ${APP_SLACK_WEBHOOK} || true
  echo
}

send_message_to_channels() {
  for channel in "${slack_channels[@]:-}"; do
    send_message "${channel}"
  done
}

slack() {
  # Set magic variables for current file dir
  __dir="$(cd "$(dirname "${BASH_SOURCE[0]}")" pwd)"
  __file="${__dir}/$(basename "${BASH_SOURCE[0]}")"
  readonly __dir __file

  cd ${__dir}

  if [ -f $(cd; pwd)/.slackrc ]; then
    . $(cd; pwd)/.slackrc
  fi

  declare -a slack_channels

  init_params ${@}
  send_message_to_channels
}

if [ "${BASH_SOURCE[0]:-}" != "${0}" ]; then
  export -f slack
else
  slack ${@}
  exit $?
fi

Далее делаем скрипт исполняемым:

 
chmod +x /usr/bin/slack

Теперь в домашней папке пользователя, от имени которого будут отправляться сообщения в slack, создаем конфигурационный файл .slackrc .

 
touch ~/.slackrc

И добавляем в него значения переменных, которые будут использоваться скриптом /usr/bin/slack. Обязательно указывать только APP_SLACK_WEBHOOK, остальные значения (APP_SLACK_CHANNEL, APP_SLACK_USERNAME, APP_SLACK_ICON_EMOJI) опциональны. В моем случае канал, в который придет сообщение, задан в настройках вебхука, поэтому дополнительно я укажу только имя (ReportBot).

 
APP_SLACK_WEBHOOK=https://hooks.slack.com/services/AAAAAAAAA/BBBBBBBBB/CCCCCCCCCCCCCCCCCCCCCCCC
APP_SLACK_USERNAME=ReportBot

Проверим отправку:

 
$ /usr/bin/slack Test message
Sending to ...
ok
$

Результат:

Один комментарий

Оставьте ответ

Ваш адрес email не будет опубликован.